#include <stdio.h>

/* 
	funkcija koja vraca broj znamenaka broja n u bazi b
   	pretpostavljamo: n > 0, b > 1 
*/
   
int broj_znamenki(int n, int b){
	int count = 0;
	while(n > 0){
		n /= b;
		++count;
		}
	return count;
	}
	
/*
	funkcija koja vraca i-tu znamenku broja n u bazi b
	pretpostavljamo n > 0, b > 1 i > 0
	(znamenke indeksiramo od 0 s desne strane)
*/

int znamenka(int n, int i, int b){
	while(i-- > 0) n /= b;
	return n % b;
	}
	
	
	
/* grupa A */	
	
double horner17(int a, double x){
	double polinom = 0;
	int n = broj_znamenki(a, 17);
	int i;
	for(i = n; i >= 0; --i) polinom += polinom * x + znamenka(a, i, 17);
	return polinom;
	}
	
void sort17(double* polje, int duljina){
	int i, j;
	for(i = 0; i < duljina - 1; ++i)
		for(j = i + 1; j < duljina; ++j)
			if( horner17(polje[i], 1024) < horner17(polje[j], 1024) ){
				double tmp = polje[i];
				polje[i] = polje[j];
				polje[j] = tmp;
				}
	}



/* grupa B */	
	
double horner19(int a, double x){
	double polinom = 0;
	int n = broj_znamenki(a, 19);
	int i;
	for(i = n; i >= 0; --i) polinom += polinom * x + znamenka(a, i, 19);
	return polinom;
	}
	
void sort19(double* polje, int duljina){
	int i, j;
	for(i = 0; i < duljina - 1; ++i)
		for(j = i + 1; j < duljina; ++j)
			if( horner19(polje[i], 2048) > horner19(polje[j], 2048) ){
				double tmp = polje[i];
				polje[i] = polje[j];
				polje[j] = tmp;
				}
	}





/* grupa C */	
	
double horner23(int a, double x){
	double polinom = 0;
	int n = broj_znamenki(a, 23);
	int i;
	for(i = n; i >= 0; --i) polinom += polinom * x + znamenka(a, i, 23);
	return polinom;
	}
	
void sort23(double* polje, int duljina){
	int i, j;
	for(i = 0; i < duljina - 1; ++i)
		for(j = i + 1; j < duljina; ++j)
			if( horner23(polje[i], 3072) < horner23(polje[j], 3072) ){
				double tmp = polje[i];
				polje[i] = polje[j];
				polje[j] = tmp;
				}
	}




/* grupa D */	
	
double horner29(int a, double x){
	double polinom = 0;
	int n = broj_znamenki(a, 29);
	int i;
	for(i = n; i >= 0; --i) polinom += polinom * x + znamenka(a, i, 29);
	return polinom;
	}
	
void sort29(double* polje, int duljina){
	int i, j;
	for(i = 0; i < duljina - 1; ++i)
		for(j = i + 1; j < duljina; ++j)
			if( horner29(polje[i], 4096) > horner29(polje[j], 4096) ){
				double tmp = polje[i];
				polje[i] = polje[j];
				polje[j] = tmp;
				}
	}





/* funkcije koje sluze za testiranje gore napisanih funkcija */


void ispis(double *polje, int duljina){
	int i;
	for(i = 0; i < duljina; ++i){
		printf("%g", polje[i]);
		if(i < duljina -1) printf(", ");
		else printf("\n");
		}
	}




int main(){
	double polje[8] = { 0.0, -1.0, 2.2, 130.1, -113.0, 3.14159, 228.4, -17.0 };
	
	printf("\nPocetno polje:\n");
	ispis(polje, 8);
	

	sort17(polje, 8);
	printf("\nPolje sortirano pomocu sort17:\n");
	ispis(polje, 7);

	sort19(polje, 8);
	printf("\nPolje sortirano pomocu sort19:\n");
	ispis(polje, 8);
	
	sort23(polje, 8);
	printf("\nPolje sortirano pomocu sort23:\n");
	ispis(polje, 8);
	
	sort29(polje, 8);
	printf("\nPolje sortirano pomocu sort29:\n");
	ispis(polje, 8);

	return 0;
	}


